unit mainu;

// Copyright  2001 by Ziff Davis Media, Inc.
// Written by Neil J. Rubenking

// Cover date - November 13, 2001

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls,
  Forms, Dialogs, tidyobj, Trayicfm, Menus, ExtCtrls, ComCtrls,
  StdCtrls, Buttons;
TYPE
  TShared = Record
    AppHandle : THandle;
    WinHandle : THandle;
    Layout    : ShortString;
    Quit      : Boolean;
  end;
VAR
  ShareData   : ^TShared;
type
  TMainForm = class(TTrayIconForm)
    pmTray               : TPopupMenu;
      mnuOpen            : TMenuItem;
      mnuResSave         : TMenuItem;
      mnuResRest         : TMenuItem;
      mnuResDel          : TMenuItem;
      mnuSmartRestore    : TMenuItem;
      mnuResOnLaunch     : TMenuItem;
      mnuNamSave         : TMenuItem;
      mnuNamRest         : TMenuItem;
      mnuNamDel          : TMenuItem;
      mnuHelp            : TMenuItem;
      mnuAbout           : TMenuItem;
      mnuExit            : TMenuItem;
    pmRestNamed          : TPopupMenu;
    pmDelNamed           : TPopupMenu;
    pcMain               : TPageControl;
      tsSaveRest         : TTabSheet;
        gbName           : TGroupBox;
          sbNamSave      : TSpeedButton;
          sbNamRest      : TSpeedButton;
          sbNamDel       : TSpeedButton;
        gbReso           : TGroupBox;
          sbResSave      : TSpeedButton;
          sbResRest      : TSpeedButton;
          sbResDel       : TSpeedButton;
          cbSmartRestore : TCheckBox;
          cbResOnLaunch  : TCheckBox;
        gbIcon           : TGroupBox;
          sbIconNorm     : TSpeedButton;
          sbIconSmall    : TSpeedButton;
      tsIcon             : TTabSheet;
        lbIcons          : TListBox;
        pbFont           : TPaintBox;
        btnMoveUp        : TBitBtn;
        btnMoveDn        : TBitBtn;
        btnSortAlpha     : TButton;
        btnInvert        : TButton;
        btnReset         : TButton;
      tsPredef           : TTabSheet;
        sbTbLr           : TSpeedButton;
        sbLrTb           : TSpeedButton;
        sbSpLr           : TSpeedButton;
        sbTbRl           : TSpeedButton;
        sbRlTb           : TSpeedButton;
        sbSpTb           : TSpeedButton;
        sbBtLr           : TSpeedButton;
        sbLrBt           : TSpeedButton;
        sbLrIn           : TSpeedButton;
        sbBtRl           : TSpeedButton;
        sbRlBt           : TSpeedButton;
        sbTbIn           : TSpeedButton;
        gbCurrent        : TGroupBox;
          pbCurrent      : TPaintBox;
          btnRefresh     : TButton;
    pnlButtons           : TPanel;
      btnClose           : TButton;
      btnAbout           : TButton;
      btnExit            : TButton;
      btnHelp            : TButton;
    StatusBar1           : TStatusBar;
    tmrCommand           : TTimer;
    tmrScroll            : TTimer;
    tmrRefresh           : TTimer;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    tmrListMove: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure pmTrayPopup(Sender: TObject);
    procedure mnuOpenClick(Sender: TObject);
    procedure mnuExitClick(Sender: TObject);
    procedure mnuSmartRestoreClick(Sender: TObject);
    procedure mnuResOnLaunchClick(Sender: TObject);
    procedure sbNamSaveClick(Sender: TObject);
    procedure sbNamRestClick(Sender: TObject);
    procedure pmRestNamedPopup(Sender: TObject);
    procedure sbResSaveClick(Sender: TObject);
    procedure sbResRestClick(Sender: TObject);
    procedure sbResDelClick(Sender: TObject);
    procedure sbIconNormClick(Sender: TObject);
    procedure sbIconSmallClick(Sender: TObject);
    procedure lbIconsStartDrag(Sender: TObject;
      var DragObject: TDragObject);
    procedure lbIconsDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure lbIconsDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure lbIconsDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure lbIconsEndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure btnSortAlphaClick(Sender: TObject);
    procedure btnInvertClick(Sender: TObject);
    procedure btnResetClick(Sender: TObject);
    procedure sbPredefClick(Sender: TObject);
    procedure pbCurrentPaint(Sender: TObject);
    procedure btnRefreshClick(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnAboutClick(Sender: TObject);
    procedure btnHelpClick(Sender: TObject);
    procedure tmrScrollTimer(Sender: TObject);
    procedure tmrRefreshTimer(Sender: TObject);
    procedure tmrCommandTimer(Sender: TObject);
    procedure btnMoveMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnMoveMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure tmrListMoveTimer(Sender: TObject);
  private
    { Private declarations }
    iniName    : String;
    datName    : String;
    tmpName    : String;
    bakName    : String;
    NuPos      : Integer;
    OldPos     : Integer;
    GoingUp    : Boolean;
    LayList    : TLayoutList;
    ResoString : String;
    fStopEv    : Integer;
    fWarnSize  : Boolean;
    fWarnLnch  : Boolean;
    fWarnActv  : Boolean;
    fWarnPred  : Boolean;
    fLastLay   : Integer;
    function LVHan : HWnd;
    function RefreshList : Boolean;
    procedure chgNotify(Sender: TObject);
    procedure CopyToListbox(TS : TStringList);
    procedure mnuDelClick(Sender: TObject);
    procedure mnuRestClick(Sender: TObject);
    procedure PredefinedLayout(which : Integer);
    procedure RestoreForRes;
    procedure SaveLayList;
    procedure WarnNoSmall;
    function WarnPredef : Boolean;

    procedure WMDisplayChange(var Msg: TWMDisplayChange);
      message WM_DISPLAYCHANGE;
  protected
    function OpenWhat : TForm; override;
  public
    { Public declarations }
    procedure DefaultHandler(var Message); override;
  end;

var
  MainForm: TMainForm;
  WinTidyMsg : Cardinal;

implementation

uses AboutBox, mmsystem, commctrl, inifiles, Registry, tidythd,
  formposu, tidyfuncs, dontu, namefmu;

{$R *.dfm}

procedure TMainForm.FormCreate(Sender: TObject);

  procedure InitFilenames;
  begin
    Application.HelpFile := ChangeFileExt(Application.Exename, '.HLP');
    iniName := ChangeFileExt(Application.Exename, '.INI');
    datName := ChangeFileExt(Application.Exename, '.DAT');
    bakName := ChangeFileExt(Application.Exename, '.BAK');
    tmpName := ChangeFileExt(Application.Exename, '.$$$');
  end;

  procedure GetIniValues;
  begin
    WITH TIniFile.Create(Ininame) DO
    try
      cbSmartRestore.Checked  := ReadBool('Settings',
        'SmartRestore', True);
      cbResOnLaunch.Checked   := ReadBool('Settings',
        'RestoreOnLaunch', True);
      mnuResOnLaunch.Checked  := cbResOnLaunch.Checked;
      mnuSmartRestore.Checked := cbSmartRestore.Checked;
      fWarnSize := ReadBool('Settings', 'WarnSize2', True);
      fWarnLnch := ReadBool('Settings', 'WarnLaunch', True);
      fWarnActv := ReadBool('Settings', 'WarnActive', True);
      fWarnPred := ReadBool('Settings', 'WarnPredef', True);
      fLastLay  := ReadInteger('Settings', 'LastLayout', 0);
      pcMain.ActivePageIndex := ReadInteger('Settings',
        'ActivePage', 0);
    finally
      Free;
    end;
  end;

  procedure InitLayoutList;
  begin
    LayList := TLayoutList.Create;
    IF FileExists(datName) THEN
    try
      LayList.LoadFromFile(datName);
    except
      On E:Exception DO
        IF E.Message = 'ver' THEN ShowMessage(sVerBad)
        ELSE IF NOT FileExists(bakName) THEN
          ShowMessage(sDatBad1)
        ELSE
          try
            LayList.LoadFromFile(bakName);
            ShowMessage(sDatBad2);
          except
            ON Exception DO
              ShowMessage(sDatBad3);
          end;
    end;
    CopyToListbox(LayList.Order.List);
    RefreshList;
  end;

  procedure CheckWarnActive;
  begin
    IF NOT ActiveDesktop THEN Exit;
    IF NOT fWarnActv THEN Exit;
    WITH TDontForm.Create(Self) DO
    try
      SetData(sADWarn1, False);
      IF ShowModal = mrAbort THEN
        fWarnActv := False;
    finally
      Free;
    end;
  end;

  procedure InitComponents;
  begin
    IF TLayout.IconsAreNormal THEN
      sbIconNorm.Down := True
    ELSE sbIconSmall.Down := True;
    lbIcons.ItemHeight := lbIcons.Canvas.TextHeight('Ay') + 2;
    gbReso.Caption     := ResoString + ' layout';
    mnuResSave.Caption := Format('S&ave %s layout', [ResoString]);
    mnuResRest.Caption := Format('R&estore %s layout', [ResoString]);
    mnuResDel.Caption  := Format('Remo&ve %s layout', [ResoString]);
    sbResRest.Enabled  := LayList.LayoutByRes(Screen.Width,
      Screen.Height) <> nil;
    sbResDel.Enabled   := sbResRest.Enabled;
    sbNamRest.Enabled  := LayList.Named.Count > 0;
    sbNamDel.Enabled   := sbNamRest.Enabled;
  end;

begin
  Inherited;
  Screen.Cursors[1] := LoadCursor(hInstance, PChar(1));
  Screen.Cursors[2] := LoadCursor(hInstance, PChar(2));
  Animate := True;
  SetupTrayIcon(1043, LoadIcon(hInstance, PChar(1043)), 'WinTidy');
  InitFilenames;
  GetPosFmIni(ininame, Self, False);
  GetIniValues;
  InitLayoutList;
  ResoString := Format('%dx%d', [Screen.Width, Screen.Height]);
  fStopEv := CreateEvent(nil, True, False,
    'PC Magazine WinTidy Stop Event');
  InitComponents;
  CheckWarnActive;
  IF cbResOnLaunch.Checked THEN
    RestoreForRes;
  tmrCommand.Enabled := True;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  PulseEvent(fStopEv);
  SetPosToIni(ininame, Self, False);
  WITH TIniFile.Create(Ininame) DO
  try
    WriteBool('Settings', 'SmartRestore', cbSmartRestore.Checked);
    WriteBool('Settings', 'RestoreOnLaunch', cbResOnLaunch.Checked);
    WriteBool('Settings', 'WarnSize2', fWarnSize);
    WriteBool('Settings', 'WarnLaunch', fWarnLnch);
    WriteBool('Settings', 'WarnActive', fWarnActv);
    WriteBool('Settings', 'WarnPredef', fWarnPred);
    WriteInteger('Settings', 'LastLayout', fLastLay);
    WriteInteger('Settings', 'ActivePage', pcMain.ActivePageIndex);
  finally
    Free;
  end;
  LayList.Order.FromDesktop;
  LayList.Order.SetOrder(lbIcons.Items);
  SaveLayList;
  inherited;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  WITH TTidyThd.Create(chgNotify, fStopEv) DO
    Resume;
  Inherited;
end;

procedure TMainForm.FormHide(Sender: TObject);
begin
  inherited;
  PulseEvent(fStopEv);
end;

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  CASE Key OF
    VK_F1 : begin
      IF ssCtrl IN Shift THEN
        Application.HelpCommand(HELP_FINDER, 0)
      ELSE Application.HelpContext(pcMain.ActivePage.HelpContext);
      Key := 0;
    end;
    VK_TAB : begin
      IF ssCtrl IN Shift THEN
        begin
          pcMain.SelectNextPage(NOT (ssShift IN Shift));
          Key := 0;
        end;
    end;
  END;
end;

procedure TMainForm.pmTrayPopup(Sender: TObject);
VAR
  IAmActive : Boolean;
  TS        : TStringList;
  N         : Integer;
  TM        : TMenuItem;
begin
  // Make the menu items as-if modal - if the active form is not the
  // main form, disable 'em all.
  IAmActive := Screen.ActiveForm = Self;
  WITH Sender AS TPopupMenu DO
    FOR N := 0 TO Items.Count-1 DO
      Items[N].Enabled := IAmActive;
  IF NOT IAmActive THEN Exit;
  mnuResRest.Enabled := sbResRest.Enabled;
  mnuResDel.Enabled  := sbResDel.Enabled;
  mnuNamRest.Enabled := sbNamRest.Enabled;
  mnuNamDel.Enabled  := sbNamDel.Enabled;
  mnuSmartRestore.Checked := cbSmartRestore.Checked;
  mnuResOnLaunch.Checked := cbResOnLaunch.Checked;
  // Create the submenus for Restore and Remove named layout
  TS := TStringList.Create;
  try
    TS.Assign(LayList.Named);
    TS.Sort;
    mnuNamRest.Clear;
    mnuNamDel.Clear;
    FOR N := 0 TO TS.Count-1 DO
      begin
        // Add an item to the restore menu
        TM := NewItem(TS[N], 0, False, True, mnuRestClick, 0,
          Format('MnuRest%d', [N]));
        IF (N > 0) AND (N MOD 10 = 0) THEN
          TM.Break := mbBarBreak;
        mnuNamRest.Add(TM);
        // Add an item to the delete menu
        TM := NewItem(TS[N], 0, False, True, mnuDelClick, 0,
          Format('MnuDel%d', [N]));
        IF (N > 0) AND (N MOD 10 = 0) THEN
          TM.Break := mbBarBreak;
        mnuNamDel.Add(TM);
      end;
  finally
    TS.Free;
  end;
end;

procedure TMainForm.mnuOpenClick(Sender: TObject);
begin
  Show;
end;

procedure TMainForm.mnuExitClick(Sender: TObject);
begin
  TrulyClose;
end;

procedure TMainForm.mnuSmartRestoreClick(Sender: TObject);
begin
  WITH mnuSmartRestore DO Checked := NOT Checked;
  cbSmartRestore.Checked := mnuSmartRestore.Checked;
end;

procedure TMainForm.mnuResOnLaunchClick(Sender: TObject);
begin
  WITH mnuResOnLaunch DO Checked := NOT Checked;
  cbResOnLaunch.Checked := mnuResOnLaunch.Checked;
end;

procedure TMainForm.sbNamSaveClick(Sender: TObject);
VAR
  S  : String;
  TL : TLayout;
  OK : BOolean;
begin
  S  := '';
  OK := False;
  TL := TLayout.Create;
  try
    TL.FromDesktop;
    IF TL.ReportDupes(Self.Handle, 'save and restore a layout') THEN
      Exit;
    WITH TNameForm.Create(Self) DO
    try
      IF ShowModal <> mrOK THEN Exit;
      S := GetName;
    finally
      free;
    end;
    IF (LayList.LayoutByName(S) <> nil) AND (MessageBox(Self.Handle,
      PChar(Format(sFmtOverwrite, [S])), 'WinTidy', MB_YESNO OR
      MB_ICONQUESTION) <> idYes) THEN Exit;
    TL.Name := S;
    TL.SetOrder(lbIcons.Items);
    TL.CheckIsPredef(fLastLay, pbFont.canvas);
    IF (TL.Predef >= 0) AND (NOT WarnPredef) THEN
      TL.Predef := -1;
    LayList.AddLayout(TL);
    SaveLayList;
    sbNamRest.Enabled := True;
    sbNamDel.Enabled  := True;
    OK                := True;
  finally
    IF NOT OK THEN TL.Free;
  end;
end;

procedure TMainForm.sbNamRestClick(Sender: TObject);
VAR P : TPoint;
begin
  WITH Sender AS TSpeedButton DO
    begin
      P := Point(Left + 8, Top + Height);
      P := Parent.ClientToScreen(P);
      PopupMenu.Popup(P.X, P.Y);
    end;
end;

procedure TMainForm.pmRestNamedPopup(Sender: TObject);
VAR
  TS : TStringList;
  N  : Integer;
  TM : TMenuItem;
begin
  // Create the popup menu to restore or remove a named layout
  TS := TStringList.Create;
  try
    TS.Assign(LayList.Named);
    TS.Sort;
    WITH Sender AS TPopupMenu DO
      begin
        Items.Clear;
        FOR N := 0 TO TS.Count-1 DO
          begin
            IF Sender = pmRestNamed THEN
              TM := NewItem(TS[N], 0, False, True, mnuRestClick, 0,
                Format('MnuRest%d', [N]))
            ELSE
              TM := NewItem(TS[N], 0, False, True, mnuDelClick, 0,
                Format('MnuDel%d', [N]));
            IF (N > 0) AND (N MOD 10 = 0) THEN
              TM.Break := mbBarBreak;
            Items.Add(TM);
          end;
      end;
  finally
    TS.Free;
  end;
end;

procedure TMainForm.sbResSaveClick(Sender: TObject);
VAR
  TL : TLayout;
  OK : Boolean;
begin
  OK := False;
  TL := TLayout.Create;
  try
    TL.FromDesktop;
    IF TL.ReportDupes(Self.Handle, 'save and restore a layout') THEN
      Exit;
    TL.Wid := Screen.Width;
    TL.Hig := Screen.Height;
    TL.SetOrder(lbIcons.Items);
    TL.CheckIsPredef(fLastLay, pbFont.Canvas);
    IF (TL.Predef >= 0) AND (NOT WarnPredef) THEN
      TL.Predef := -1;
    LayList.AddLayout(TL);
    SaveLayList;
    sbResRest.Enabled := True;
    sbResDel.Enabled  := True;
    OK := True;
  finally
    IF NOT OK THEN TL.Free;
  end;
end;

procedure TMainForm.sbResRestClick(Sender: TObject);
begin
  RestoreForRes;
end;

procedure TMainForm.sbResDelClick(Sender: TObject);
begin
  IF MessageBox(Self.Handle, PChar(FOrmat(sFmtDelRes, [ResoString])),
    'WinTidy', MB_YESNO OR MB_ICONQUESTION) = idYes THEN
    begin
      LayList.DelLayout(Screen.Width, Screen.Height);
      sbResRest.Enabled := False;
      sbResDel.Enabled := False;
    end;
end;

procedure TMainForm.sbIconNormClick(Sender: TObject);
VAR TL : TLayout;
begin
  IF TLayout.IconsAreNormal THEN Exit;
  TL := TLayout.Create;
  try
    TL.FromDesktop;
    TL.SetListViewStyleTo(True);
    PredefinedLayout(fLastLay);
    pbCurrent.Refresh;
  finally
    TL.Free;
  end;
end;

procedure TMainForm.sbIconSmallClick(Sender: TObject);
VAR TL : TLayout;
  function CheckWarnIconSize : Boolean;
  begin
    IF fWarnSize THEN
      WITH TDontForm.Create(Self) DO
      try
        SetData(sADWarn2, True);
        CASE ShowModal OF
          mrCancel : Result := False;
          mrAbort : begin
            Result := True;
            fWarnSize := False;
          end;
          ELSE    Result := True;
        END;
      finally
        Free;
      end
    ELSE Result := True;
  end;


begin
  IF NOT TLayout.IconsAreNormal THEN Exit;
  IF ActiveDesktop THEN
    begin
      sbIconNorm.Down := True;
      MessageBox(Handle, sADWarn3, 'WinTidy', MB_OK OR MB_ICONSTOP);
      Exit;
    end
  ELSE IF NOT CheckWarnIconSize THEN
    begin
      sbIconNorm.Down := True;
      Exit;
    end;
  TL := TLayout.Create;
  try
    TL.FromDesktop;
    TL.SetListViewStyleTo(False);
    PredefinedLayout(fLastLay);
    pbCurrent.Refresh;
  finally
    TL.Free;
  end;
end;

procedure TMainForm.lbIconsStartDrag(Sender: TObject;
  var DragObject: TDragObject);
begin
  OldPos := (Sender AS TListBox).ItemIndex;
end;

procedure TMainForm.lbIconsDragOver(Sender, Source: TObject;
  X, Y: Integer; State: TDragState; var Accept: Boolean);
// Track the new position under the cursor. If the cursor moves
// off the listbox, scroll in the appropriate direction by
// enabling the tmrScroll timer.
begin
  NuPos := (Sender AS TListBox).ItemAtPos(Point(X, Y), True);
  Accept := (Source=Sender) AND (NuPos <> -1);
  IF Accept THEN
    WITH Sender AS TListBox DO
      begin
        IF Y > Height-ItemHeight THEN
          BEGIN
            GoingUp := False;
            tmrScroll.Enabled := True;
            DragCursor := 2;
          END
        ELSE IF Y < ItemHeight THEN
          BEGIN
            GoingUp := True;
            tmrScroll.Enabled := True;
            DragCursor := 1;
          END
        ELSE
          begin
            tmrScroll.Enabled := False;
            DragCursor := crDrag;
          end;
        ItemIndex := NuPos;
      end;
end;

procedure TMainForm.lbIconsDragDrop(Sender, Source: TObject;
  X, Y: Integer);
begin
  WITH Sender AS TListBox DO
    begin
      Items.Move(OldPos, NuPos);
      ItemIndex := NuPos;
    end;
end;

procedure TMainForm.lbIconsDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);

  function D(const S : String) : String;
  // Strip off the initial digit-and-colon that identifies the item's
  // location. If it's a shortcut, strip off the extension.
  begin
    Result := Copy(S, digs+2, MAX_PATH);
    CASE S[1] OF
      '2','4' : ;
      ELSE Exit;
    END;
    SetLength(Result, Length(Result) -
      Length(ExtractFileExt(Result)));
  end;

begin
  WITH Control AS TListBox DO
    begin
      Canvas.Font.Style := [];
      CASE Items[Index][1] OF
        '1' : Canvas.Font.Style := [fsBold, fsItalic];
        '2' : Canvas.Font.Style := [fsItalic];
        '3' : Canvas.Font.Style := [fsItalic, fsUnderline];
        '4' : Canvas.Font.Style := [];
        '5' : Canvas.Font.Style := [fsUnderline]; 
      end;
      Canvas.FillRect(Rect);
      Canvas.TextRect(Rect, Rect.Left+2, Rect.Top, D(Items[Index]));
    end;
end;

procedure TMainForm.lbIconsEndDrag(Sender, Target: TObject;
  X, Y: Integer);
begin
  tmrScroll.Enabled := False;
  DragCursor := crDrag;
end;

procedure TMainForm.btnMoveMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  GoingUp := Sender = btnMoveUp;
  tmrListMove.Interval := 500;
  tmrListMove.Enabled := True;
end;

procedure TMainForm.btnMoveMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  IF tmrListMove.Enabled THEN
    begin
      tmrListMove.Enabled := False;
      IF tmrListMove.Interval = 500 THEN
        tmrListMoveTimer(tmrListMove);
    end;
end;

function SortAlpha(List: TStringList; Index1, Index2: Integer): Integer;
// The first two characters indicate the icon's type (e.g. "1:" for a
// non-file icon). Compare without those to start. If otherwise equal,
// compare the entire string.
begin
  Result := AnsiCompareText(Copy(List[Index1], digs+1, MAX_PATH),
    Copy(List[Index2], digs+1, MAX_PATH));
  IF Result = 0 THEN Result := AnsiCompareText(List[Index1], List[Index2]);
end;


procedure TMainForm.btnSortAlphaClick(Sender: TObject);
VAR TS : TStringList;
begin
  TS := TStringList.Create;
  try
    TS.Assign(lbIcons.Items);
    TS.CustomSort(SortAlpha);
    CopyToListbox(TS);
  finally
    TS.Free;
  end;
end;

procedure TMainForm.btnInvertClick(Sender: TObject);
// Invert the list by swapping first item with last, second with
// second-to-last, etc.
VAR N : Integer;
begin
  FOR N := 0 TO (lbIcons.Items.Count DIV 2)-1 DO
    lbIcons.Items.Exchange(N, lbIcons.Items.Count-Succ(N));
end;

procedure TMainForm.btnResetClick(Sender: TObject);
begin
  lbIcons.Items.Clear;
  RefreshList;
end;

procedure TMainForm.sbPredefClick(Sender: TObject);
begin
  WITH Sender AS TSpeedButton DO
    PredefinedLayout(Tag);
end;

procedure TMainForm.pbCurrentPaint(Sender: TObject);
// Paint a "map" of the desktop showing icon locations; display
// areas occupied by taskbars/toolbars with cross-hatching
VAR
  lvR    : TRect;   // rectangle occupied by listview
  TL     : TLayout;
  pbW    : Integer; // paintbox's width
  pbH    : Integer; // paintbox's height
  scrW   : Integer; // screen width
  scrH   : Integer; // screen height
  bigW   : Integer; // actual icon width
  bigH   : Integer; // actual icon height
  icoW   : Integer; // scaled icon width
  icoH   : Integer; // scaled icon height
  icoR   : TRect;   // scaled icon rectangle
  N      : Integer;
  BarRgn : HRgn;
  TmpRgn : HRgn;
  Rects  : TList;

  function FoundAndAdd(R : TRect) : Boolean;
  VAR
    N : Integer;
    vR,dR : TRect;
  begin
    Result := False;
    Rects.Insert(0, Pointer(PointToSmallPoint(R.TopLeft)));
    FOR N := 1 TO Rects.Count-1 DO
      begin
        vR.TopLeft := SmallPointToPoint(TSmallPoint(Rects[N]));
        vR.Right := vR.Left + IcoW;
        vR.Bottom := vR.Top + IcoH;
        IF IntersectRect(dR, vR, R) THEN
          begin
            Result := True;
            Exit;
          end;
      end;
  end;
begin
  GetWindowRect(lvHan, lvR);
  TL := TLayout.Create;
  try
    TL.FromDesktop;
    WITH Sender AS TPaintbox DO
      begin
        pbW  := Width;
        pbH  := Height;
        scrW := Screen.Width;
        scrH := Screen.Height;
        IF TL.IconsAreNormal THEN
          begin
            WITH TRegIniFile.Create('Control Panel\desktop\'+
              'WindowMetrics') DO
            try
              bigW := ReadInteger('', 'Shell Icon Size', 32)
            finally
              Free;
            end;
            bigH := bigW;
            icoW := Round((bigW*pbW) / scrW) + 1;
            icoH := Round((bigH*pbH) / scrH) + 1;
          end
        ELSE
          begin
            bigW := TL.Longest(pbFont.Canvas);
            bigH := GetSystemMetrics(SM_CYSMICON);
            icoW := Round((bigW*pbW) / scrW) - 1;
            icoH := Round((bigH*pbH) / scrH);
          end;
        // Paint the simulated desktop
        Canvas.Brush.Color := GetSysColor(COLOR_DESKTOP);
        Canvas.Pen.Color   := Brush.Color;
        Canvas.Brush.Style := bsSolid;
        Canvas.FillRect(Rect(0, 0, pbW, pbH));
        // Cross-hatch the area occupied by toolbars
        BarRgn := CreateRectRgn(0, 0, pbW, pbH);
        TmpRgn := CreateRectRgn(
          Round((lvR.Left*pbW)  / scrW),
          Round((lvR.Top*pbH)   / scrH),
          Round((lvR.Right*pbW) / scrW),
          Round((lvR.Bottom*pbH)/ scrH));
        CombineRgn(BarRgn, BarRgn, TmpRgn, RGN_DIFF);
        DeleteObject(TmpRgn);
        Canvas.Brush.Color := GetSysColor(COLOR_3DHIGHLIGHT);
        Canvas.Brush.Style := bsDiagCross;
        FillRgn(Canvas.Handle, BarRgn, Canvas.Brush.Handle);
        DeleteObject(BarRgn);
        Canvas.Brush.Style := bsSolid;
        // Draw the scaled icons
        Canvas.Pen.Color   := clBlack;
        Canvas.Brush.Color := clWhite;
        Rects := TList.Create;
        try
          FOR N := 0 TO TL.List.Count-1 DO
            begin
              WITH TLayout.PointerToPoint(TL.List.Objects[N]) DO
                begin
                  icoR.Left   := Round(((lvR.Left+X) * pbW) / scrW);
                  icoR.Top    := Round(((lvR.Top +Y) * pbH) / scrH)+2;
                  icoR.Right  := icoR.Left + icoW;
                  icoR.Bottom := icoR.Top + icoH;
                  IF FoundAndAdd(icoR) THEN
                    Canvas.Brush.Color := clRed
                  ELSE Canvas.Brush.Color := clWhite;
                  Canvas.Rectangle(icoR);
                end;
            end;
        finally
          Rects.Free;
        end;
      end;
  finally
    TL.Free;
  end;
end;

procedure TMainForm.btnRefreshClick(Sender: TObject);
begin
  pbCurrent.Refresh;
end;

procedure TMainForm.btnExitClick(Sender: TObject);
begin
  TrulyClose;
end;

procedure TMainForm.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.btnAboutClick(Sender: TObject);
begin
  WITH TAboutForm.Create(Self) DO
  try
    ShowModal;
  finally
    free;
  end;
end;

procedure TMainForm.btnHelpClick(Sender: TObject);
begin
  Application.HelpContext(pcMain.ActivePage.HelpContext);
end;

procedure TMainForm.tmrScrollTimer(Sender: TObject);
// This timer scrolls the icon list in the specified direction
begin
  WITH lbIcons DO
    IF GoingUp THEN
      IF TopIndex > 0 THEN TopIndex := TopIndex - 1
      ELSE
        begin
          tmrScroll.Enabled := False;
          DragCursor := crDrag;
        end
    ELSE
      IF TopIndex < Items.Count-1 THEN TopIndex := TopIndex + 1
      ELSE 
        begin
          tmrScroll.Enabled := False;
          DragCursor := crDrag;
        end;
end;

procedure TMainForm.tmrRefreshTimer(Sender: TObject);
// This timer is activated when a change is reported in one of the
// desktop folders. It keeps checking until the change percolates
// through to the listview (or until it has tried ten times).
begin
  WITH Sender AS TTimer DO
    begin
      Tag := Tag-1;
      IF Tag < 0 THEN
        Enabled := False
      ELSE Enabled := NOT RefreshList;
    end;
end;

procedure TMainForm.tmrCommandTimer(Sender: TObject);
// At startup, WinTidy enables this one-shot timer. When the timer
// triggers, it checks for command-line switches.
VAR TL : TLayout;
begin
  tmrCommand.Enabled := False;
  WITH ShareData^ DO
    begin
      IF Layout <> '' THEN
        begin
          TL := LayList.LayoutByName(Layout);
          IF TL = nil THEN
            begin
              MessageBox(Handle, PChar(Format(sFmtNone, [Layout])),
                'WinTidy', MB_OK OR MB_ICONSTOP);
              Exit;
            end;
          TL.ToDesktop(pbFont.Canvas);
          TL.ReportRemains(Self.Handle, Format('"%s"', [Layout]));
          CopyToListbox(TL.List);
          RefreshList;
          pbCurrent.Refresh;
          IF TL.NormIcon THEN
            sbIconNorm.Down := True
          ELSE
            begin
              IF ActiveDesktop THEN
                begin
                  WarnNoSmall;
                  sbIconNorm.Down := True
                end
              ELSE sbIconSmall.Down := True;
            end;
        end;
      IF Quit THEN TrulyClose;
    end;
end;

procedure TMainForm.tmrListMoveTimer(Sender: TObject);
// This timer is enabled while the Up or Down button is being held
// down. It kicks in after 500 ms, then changes its own interval
// to 100 ms.
VAR NewIndex : Integer;
begin
  (Sender AS TTimer).Interval := 100;
  WITH lbIcons DO
    IF GoingUp THEN
      begin
        IF ItemIndex > 0 THEN
          begin
            NewIndex := ItemIndex - 1;
            Items.Move(itemIndex, NewIndex);
            ItemIndex := NewIndex;
          end
        ELSE (Sender AS TTimer).Enabled := False;
      end
    ELSE
      begin
        IF (ItemIndex >= 0) AND (ItemIndex < Items.Count-1) THEN
           begin
             NewIndex := ItemIndex + 1;
             Items.Move(ItemIndex, NewIndex);
             ItemIndex := NewIndex;
          end
        ELSE (Sender AS TTimer).Enabled := False;
      end;
end;

function TMainForm.LVHan: HWnd;
// Return the handle of the desktop listview
begin
  Result := GetLVHan;
end;

function TMainForm.RefreshList : Boolean;
// Re-read the contents of the desktop, maintaining the existing
// order in the listbox. Drop any items no longer present. Append
// any that are new. Keep the same item selected, if possible.
// Return True if there actually WAS a change.
VAR
  WasSel : String;
  WasTop : Integer;
  TL     : TLayout;
begin
  WasSel := '';
  IF lbIcons.ItemIndex >= 0 THEN
    WasSel := lbIcons.Items[lbIcons.ItemIndex];
  WasTop := lbIcons.TopIndex;
  TL := TLayout.Create;
  try
    TL.FromDesktop;
    Result := TL.SetOrder(lbIcons.Items);
    CopyToListbox(TL.List);
  finally
    TL.Free;
  end;
  lbIcons.ItemIndex := lbIcons.Items.IndexOf(WasSel);
  IF (lbIcons.ItemIndex < 0) AND (lbIcons.Count > 0) THEN
    lbIcons.ItemIndex := 0;
  lbIcons.TopIndex := WasTop;
end;

procedure TMainForm.chgNotify(Sender: TObject);
// The change notification thread calls this method when it detects
// a change. The file-system change doesn't show up in the
// listview immediately. Also, a single change can trigger multiple
// notifications. To get around both these problems, this function
// starts a timer that will check for changes up to ten times.
begin
  tmrRefresh.Tag := 10;
  tmrRefresh.Enabled := true;
end;

procedure TMainForm.CopyToListbox(TS : TStringList);
VAR WasSel : String;
begin
  WasSel := '';
  IF lbIcons.ItemIndex >= 0 THEN
    WasSel := lbIcons.Items[lbIcons.ItemIndex];
  lbIcons.Items.Assign(TS);
  lbIcons.ItemIndex := lbIcons.Items.IndexOf(WasSel);
  IF (lbIcons.ItemIndex < 0) AND (lbIcons.Count > 0) THEN
    lbIcons.ItemIndex := 0;
end;

procedure TMainForm.mnuDelClick(Sender: TObject);
begin
  IF MessageBox(Self.Handle, PChar(Format(sFmtDelNamed,
    [(Sender AS TMenuItem).Caption])), 'WinTidy', MB_YESNO OR
    MB_ICONQUESTION) = idYes THEN
    begin
      LayList.DelLayout((Sender AS TMenuItem).Caption);
      sbNamRest.Enabled := LayList.Named.Count > 0;
      sbNamDel.Enabled := sbNamRest.Enabled;
    end;
end;

procedure TMainForm.mnuRestClick(Sender: TObject);
VAR TL : TLayout;
begin
  TL := LayList.LayoutByName((Sender AS TMenuItem).Caption);
  IF TL <> nil THEN
    begin
      TL.ToDesktop(pbFont.Canvas);
      TL.ReportRemains(Self.Handle,
        Format('"%s"', [(Sender AS TMenuItem).Caption]));
      CopyToListbox(TL.List);
      RefreshList;
      pbCurrent.Refresh;
      IF TL.NormIcon THEN
        sbIconNorm.Down := True
      ELSE
        begin
          IF ActiveDesktop THEN
            begin
              WarnNoSmall;
              sbIconNorm.Down := True
            end
          ELSE sbIconSmall.Down := True;
        end;
    end;
end;

procedure TMainForm.PredefinedLayout(which : Integer);
VAR
  WasSel : String;
  TL : TLayout;
begin
  fLastLay := which;
  IF lbIcons.ItemIndex >= 0 THEN
    WasSel := lbIcons.Items[lbIcons.ItemIndex]
  ELSE WasSel := '';
  TL := TLayout.Create;
  try
    TL.FromDesktop;
    IF TL.ReportDupes(Self.Handle, 'apply a predefined layout') THEN
      Exit;
    TL.SetOrder(lbIcons.Items);
    TL.SetLayout(which, pbFont.Canvas);
    TL.ToDesktop(pbFont.Canvas);
    CopyToListbox(TL.List);
    pbCurrent.Refresh;
  finally
    TL.Free;
  end;
  IF WasSel <> '' THEN
    lbIcons.ItemIndex := lbIcons.Items.IndexOf(WasSel);
end;

procedure TMainForm.RestoreForRes;
VAR TL : TLayout;
begin
  TL := LayList.LayoutByRes(Screen.Width, Screen.Height);
  IF TL <> nil THEN
    begin
      TL.ToDesktop(pbFont.Canvas);
      TL.ReportRemains(Self.Handle,
        Format('%dx%d', [Screen.Width, Screen.Height]));
      CopyToListbox(TL.List);
      RefreshList;
      pbCurrent.Refresh;
      IF TL.NormIcon THEN
        sbIconNorm.Down := True
      ELSE
        begin
          IF ActiveDesktop THEN
            begin
              WarnNoSmall;
              sbIconNorm.Down := True
            end
          ELSE sbIconSmall.Down := True;
        end;
    end;
end;

procedure TMainForm.SaveLayList;
begin
  DeleteFile(tmpName);
  try
    LayList.SaveToFile(tmpName);
    DeleteFile(bakName);
    RenameFile(datName, bakName);
    RenameFIle(tmpName, datName);
  except
    ON Exception DO ShowMessage('Exception during save');
  end;
end;

procedure TMainForm.WarnNoSmall;
begin
  MessageBox(Handle, sADWarn4, 'WinTidy', MB_OK OR MB_ICONSTOP);
end;

function TMainForm.WarnPredef : Boolean;
begin
  IF fWarnPred THEN
    WITH TDontForm.Create(Self) DO
    try
      SetData(sPredef, True);
      CASE ShowModal OF
        mrCancel : Result := False;
        mrAbort : begin
          Result := True;
          fWarnPred := False;
        end;
        ELSE    Result := True;
      END;
    finally
      Free;
    end
  ELSE Result := True;
end;

procedure TMainForm.WMDisplayChange(var Msg: TWMDisplayChange);
begin
  ResoString := Format('%dx%d', [Screen.Width, Screen.Height]);
  gbReso.Caption := ResoString + ' layout';
  mnuResSave.Caption := Format('S&ave %s layout', [ResoString]);
  mnuResRest.Caption := Format('R&estore %s layout', [ResoString]);
  mnuResDel.Caption := Format('Remo&ve %s layout', [ResoString]);
  sbResRest.Enabled := LayList.LayoutByRes(Screen.Width, Screen.Height) <> nil;
  sbResDel.Enabled := sbResRest.Enabled;
  IF cbSmartRestore.Checked THEN
    RestoreForRes;
end;

function TMainForm.OpenWhat: TForm;
begin
  Result := Screen.ActiveForm;
  IF Result = nil THEN Result := Self;
end;


procedure TMainForm.DefaultHandler(var Message);
// If a second instance performs some automatic action, it will tell
// this instance to refresh its view.
VAR
  TL : TLayout;
begin
  inherited;
  WITH TMessage(Message) DO
    IF Msg = WinTidyMsg THEN
      begin
        WITH ShareData^ DO
          begin
            IF Layout = '' THEN Exit;
            TL := LayList.LayoutByName(Layout);
            IF TL = nil THEN
              begin
                MessageBox(Handle, PChar(Format(sFmtNone, [Layout])),
                  'WinTidy', MB_OK OR MB_ICONSTOP);
                Exit;
              end;
            TL.ToDesktop(pbFont.Canvas);
            TL.ReportRemains(Self.Handle,
              Format('"%s"', [Layout]));
            CopyToListbox(TL.List);
            RefreshList;
            pbCurrent.Refresh;
            IF TL.NormIcon THEN
              sbIconNorm.Down := True
            ELSE
              begin
                IF ActiveDesktop THEN
                  begin
                    WarnNoSmall;
                    sbIconNorm.Down := True
                  end
                ELSE sbIconSmall.Down := True;
              end;
          end;
      end;
end;

end.

