program wintidy;

// Copyright  2001 by Ziff Davis Media, Inc.
// Written by Neil J. Rubenking

{$R 'moreres.res' 'moreres.rc'}

uses
  Forms,
  Windows,
  SysUtils,
  commctrl,
  Registry,
  mainu in 'mainu.pas' {MainForm},
  AboutBox in 'Aboutbox.pas' {AboutForm},
  trayicfm in 'Trayicfm.pas' {TrayIconForm},
  tidyobj in 'tidyobj.pas',
  tidythd in 'tidythd.pas',
  formposu in 'formposu.pas',
  tidyfuncs in 'tidyfuncs.pas',
  allfuncs in 'allfuncs.pas',
  dontu in 'dontu.pas' {DontForm},
  namefmu in 'namefmu.pas' {NameForm};

{$R *.res}
VAR
  hMap : THandle;
CONST
  MainMapName : PChar = 'PC Magazine WinTidy Shared '+
    '{C20BA5C1-CD84-44F1-ABB4-AF84CF7273B9}';

  function CheckAutoArrange : BOolean;
  VAR
    lvHan : HWnd;
    L     : DWord;
  begin
    lvHan  := GetLVHan;
    Result := False;
    WHILE True DO
      begin
        L := GetWindowLong(lvHan, GWL_STYLE);
        IF L AND LVS_AUTOARRANGE = 0 THEN
          begin
            Result := True;
            Exit;
          end;
        IF MessageBox(0, sAAWarn, 'WinTidy', MB_ICONSTOP OR
          MB_OKCANCEL) <> idOK THEN Exit;
      end;
  end;

  procedure ParseCmdLine;
  VAR
    N : Integer;
    S : String;
  begin
    WITH ShareData^ DO
      begin
        Quit := False;
        Layout := '';
      end;
    FOR N := 1 TO ParamCount DO
      begin
        S := ParamStr(N);
        IF (Length(S) = 2) AND (S[1] IN ['/','-']) AND
          (UpCase(S[2]) = 'Q') THEN
          ShareData^.Quit := True
        ELSE ShareData^.Layout := Trim(S);
      end;
  end;

begin
  IF NOT CheckAutoArrange THEN Exit;
  WinTidyMsg := RegisterWindowMessage(MainMapName);
  hMap := OpenFileMapping(FILE_MAP_ALL_ACCESS, False, MainMapName);
  IF hMap = 0 THEN // first instance
    begin
      hMap := CreateFileMapping($FFFFFFFF, NIL, PAGE_READWRITE, 0,
        SizeOf(TShared), MainMapName);
      ShareData := MapViewOfFile(hMap, FILE_MAP_ALL_ACCESS, 0, 0, 0);
      ParseCmdLine;
      Application.Initialize;
      Application.Title := 'WinTidy';
      Application.CreateForm(TMainForm, MainForm);
  MainForm.HandleNeeded;
      ShareData^.AppHandle := Application.Handle;
      ShareData^.WinHandle := MainForm.Handle;
      Application.Run;
    end
  ELSE
    begin
      ShareData := MapViewOfFile(hMap, FILE_MAP_ALL_ACCESS, 0, 0, 0);
      ParseCmdLine;
      IF IsWindowVisible(ShareData^.WinHandle) THEN
        begin
          ShowWindow(ShareData^.WinHandle, SW_SHOWNORMAL);
          SetForegroundWindow(ShareData^.WinHandle);
          BringWindowToTop(ShareData^.WinHandle);
        end;
      // wake up the first instance
      IF ShareData^.Layout <> '' THEN
        SendMessage(ShareData^.WinHandle, WinTidyMsg,
        0, 0);
    end;
  UnMapViewOfFile(ShareData);
  CloseHandle(hMap);
end.
